<?php
namespace Teknisa\CRM\Factory;

use Doctrine\ORM\EntityManager;

class crm00050000InterlocutorRevendaFactory
{
    
    protected $connection;
    
    public function __construct(EntityManager $entityManager) {
        
        $this->connection       = $entityManager->getConnection();
    }
    
    public function requestForInsertPartnerCommunication($paramsInsertPartnerCommunication){

        $insert = "INSERT INTO COMUNICAPARC (NRCOMUNICAPARC, NRPARCNEGOCIO, CDFORMACOMU, CDCOMUNICAPARC,
        NRORG, IDATIVO, DTINCLUSAO, NRORGINCLUSAO, CDOPERINCLUSAO)
         VALUES (:NRCOMUNICAPARC,
                :NRPARCNEGOCIO,
                :CDFORMACOMU,
                :CDCOMUNICAPARC,
                :NRORG,
                :IDATIVO,
                 SYSDATE,
                :NRORGINCLUSAO,
                :CDOPERINCLUSAO)";
                 
        try{
            $std = $this->connection->prepare($insert);
            $std->execute($paramsInsertPartnerCommunication);
        }
        catch(\Exception $e){
            throw $e;
        };
        
    }
    
    public function requestForInsertPartnerRelation($paramsInsertPartnerRelation){
        $insert = "INSERT INTO RELACIONAPARC (NRRELACIONAPARC, NRORG, NRPARCNEGOCIO, NRPARCNEGRELAC,
        NRTIPORELACIONA, IDATIVO, DTINCLUSAO, NRORGINCLUSAO, CDOPERINCLUSAO)
         VALUES (:NRRELACIONAPARC,
                :NRORG,
                :NRPARCNEGOCIO,
                :NRPARCNEGRELAC,
                 25,
                :IDATIVO,
                 SYSDATE,
                :NRORGINCLUSAO,
                :CDOPERINCLUSAO)";
                 
        try{
            $std = $this->connection->prepare($insert);
            $std->execute($paramsInsertPartnerRelation);
        }
        catch(\Exception $e){
            throw $e;
        };
        
    }
    
    public function requestForInsertPartnerParceria($paramsInsertPartnerRelation){
        $insert = "INSERT INTO PARCERIA (NRPARCERIA, NRPARCNEGOCIO, CDTIPOPARCEIRO, NRORG, IDATIVO,
        DTINCLUSAO, NRORGINCLUSAO, CDOPERINCLUSAO)
         VALUES (:NRPARCERIA,
                :NRPARCNEGOCIO,
                :CDTIPOPARCEIRO,
                :NRORG,
                :IDATIVO,
                 SYSDATE,
                :NRORGINCLUSAO,
                :CDOPERINCLUSAO)";
                 
        try{
            $std = $this->connection->prepare($insert);
            $std->execute($paramsInsertPartnerRelation);
        }
        catch(\Exception $e){
            throw $e;
        };
        
    }
    
    public function requestForDeletePartnerCommunication($paramsDeletePartnerCommunication){
        
        $delete = "DELETE COMUNICAPARC WHERE NRPARCNEGOCIO = :NRPARCNEGOCIO";
        
        try{
            $std = $this->connection->prepare($delete);
            $std->execute($paramsDeletePartnerCommunication);
        }
        catch(\Exception $e){
            throw $e;
        };
        
    }
    
    public function requestForUpdateRelationState($paramsUpdateRelationState){
        
        $update = "UPDATE RELACIONAPARC SET IDATIVO = :IDATIVO WHERE NRPARCNEGOCIO = :NRPARCNEGOCIO AND NRPARCNEGRELAC = :NRPARCNEGRELAC";
        
        try{
            $std = $this->connection->prepare($update);
            $std->execute($paramsUpdateRelationState);
        }
        catch(\Exception $e){
            throw $e;
        };
        
    }
    
    public function requestForInactivatePartner($paramsInactivatePartner){
        
        $update = "UPDATE PARCNEGOCIO SET IDATIVO = 'N' WHERE NRPARCNEGOCIO = :NRPARCNEGOCIO";
        
        try{
            $std = $this->connection->prepare($update);
            $std->execute($paramsInactivatePartner);
        }
        catch(\Exception $e){
            throw $e;
        };
        
    }
    
    public function requestForDeleteResaleRelation($paramsDeleteResaleRelation){
       
       $delete = "DELETE RELACIONAPARC WHERE NRPARCNEGOCIO = :NRPARCNEGOCIO AND NRPARCNEGRELAC = :NRPARCNEGRELAC";
       
       try{
            $std = $this->connection->prepare($delete);
            $std->execute($paramsDeleteResaleRelation);
        }
        catch(\Exception $e){
            throw $e;
        };
        
    }
    

}
?>