describe("DTMessages", function() {

	var dtMessages;
	var errorMap = {
		"ECONTAINERSAVE": "Cannot save containers.json file",
		"EPIPE": "Broken pipe.",
		"EPERM": "Operation not permitted.",
		"EACCES": "Permission denied.",
		"EEXIST": "File exists.",
		"EISDIR": "Is a directory.",
		"EMFILE": "Too many open files in system.",
		"ENOENT": "No such file or directory.",
		"ENOTDIR": "Not a directory.",
		"ENOTEMPTY": "Directory not empty.",
		"ETIMEDOUT": "Operation timed out.",
		"EADDRINUSE": "Address already in use.",
		"ECONNRESET": "Connection reset by peer.",
		"ECONNREFUSED": "Connection refused."
	};

	beforeEach(function(){
		window.name = "main";
		window.templateUrl = "../../dyman/templates/dyman/";
		window.metadataUrl = "/json_test/test";
		window.serviceUrl = "../backend/service/index.php";
		window.inCustomizationMode = true;
		module('ZeedhiApp');
		dtMessages = new DTMessages;
	});

	it("GetMessageContainerWasReseted should return a message default when is called.", function () {
		var msg = dtMessages.getMessageContainerWasReseted();
		expect(msg).toBe("Container customization reseted.");
	});

	it("GetMessageContainerWasReseted should return a message with the concatenated param.", function () {
		var number = 55;
		var msg = dtMessages.getMessageContainerWasReseted(number);
		expect(msg).toBe("Container customization reseted."+ " ["+number+" objects was deleted]");
	});

	it("DTMessages dot 'DT CODE MESSAGE' should return a message.", function () {
		expect(dtMessages.CANT_CONNECT).toBe("Can't connect.");
		expect(dtMessages.RELOAD_CONTAINER).toBe("Deseja atualizar o container?");
		expect(dtMessages.CHECK_MAIN_WINDOW).toBe("An error occurred. Please check your main window.");
		expect(dtMessages.PROJECT_ID_SAVED).toBe("Project id saved successfully!");
		expect(dtMessages.CONTAINER_PROJECT_ID_FAIL).toBe("The containers.json doesn't have a project id.");
		expect(dtMessages.CONTAINER_WAS_CREATED).toBe('Container was created successfully');
		expect(dtMessages.LOGIN_NOT_ACCOMPLISHED).toBe("Login not accomplished! Please, try connect the server.");
		expect(dtMessages.LOGIN_ACCOMPLISHED).toBe("Login accomplished with success!");
		expect(dtMessages.LOGIN_NO_OTHER_CLIENTS).toBe('No other clients connected');
		expect(dtMessages.CONFIRM_RESET).toBe("Are you sure you want to reset?");
		expect(dtMessages.CONFIRM_DELETE).toBe("Are you sure you want to delete?");
		expect(dtMessages.CUSTOM_OUTDATED).toBe("Customization is outdated. Do you want to save anyway?");
		expect(dtMessages.CUSTOM_SAVED).toBe("Customization saved with success.");
		expect(dtMessages.CUSTOM_WASNT_SAVED).toBe("Customization not saved.");
		expect(dtMessages.CUSTOM_ITEM_WAS_DELETED).toBe("Item customization was deleted.");
		expect(dtMessages.CUSTOM_ITEM_WASNT_DELETED).toBe("Item customization wasn't deleted.");
		expect(dtMessages.CUSTOM_CONTAINER_WASNT_RESETED).toBe("Container customization wasn't reseted.");
		expect(dtMessages.CUSTOM_FILE_WAS_DELETED).toBe("Customization file was deleted.");
		expect(dtMessages.CUSTOM_FILE_WASNT_DELETED).toBe("Customization file wasn't deleted.");
		expect(dtMessages.FILE_INVALID_NAME).toBe("Invalid file name");
		expect(dtMessages.FILE_INVALID_PATH).toBe("Invalid path");
		expect(dtMessages.FILE_CANT_SAVE).toBe("You can't save this file, Because it is out of your file system");
		expect(dtMessages.FILE_SAVED_SUCCESSFULLY).toBe('File saved successfully');
		expect(JSON.stringify(dtMessages.FILE_ERROR_MAP)).toBe(JSON.stringify(errorMap));
	});

});
